package com.hp.test;

import java.net.UnknownHostException;

import org.apache.http.auth.AuthScope;
import org.apache.http.auth.UsernamePasswordCredentials;
import org.apache.http.impl.client.DefaultHttpClient;
import org.jboss.resteasy.client.ClientExecutor;
import org.jboss.resteasy.client.ProxyFactory;
import org.jboss.resteasy.client.core.executors.ApacheHttpClient4Executor;

public class ClientInServiceImpl implements ClientInService
{

  @Override
  public String helloWorld()
  {
    try
    {
      ClientInService proxy =
        ProxyFactory.create(ClientInService.class, "http://nohost.nowhere.nodomain", createClientExecutor());
      return proxy.helloWorld();
    }
    catch (RuntimeException e)
    {
      // We expect a "java.net.UnknownHostException: nohost.nowhere.nodomain" here
      if (e.getCause() instanceof UnknownHostException)
      {
        return "Sorry, host not found, but test PASSED!";
      }
      throw e;
    }
  }

  private ClientExecutor createClientExecutor()
  {
    DefaultHttpClient httpClient = new DefaultHttpClient();
    UsernamePasswordCredentials credentials = new UsernamePasswordCredentials("rod", "koala");
    httpClient.getCredentialsProvider().setCredentials(AuthScope.ANY, credentials);
    ClientExecutor clientExecutor = new ApacheHttpClient4Executor(httpClient);
    return clientExecutor;
  }
}
